/*---------------------------------------------------------\
|    From: Ekobots Innovation Ltda - www.ekobots.com.br    |
|       by: Juan Sirgado y Antico - www.jsya.com.br        |
|----------------------------------------------------------|
|            Program Windmill - 2015/07/10                 |
|               All rights reserved 2015                   |
|---------------------------------------------------------*/
fn=60; // object resolution
// Tree versions for the windmill
// V1 - belt
// V2 - external gear
// V3 - internal gear
//windmill_V1();
//windmill_V2();
windmill_V3();
//---------------------------------------------------------|
module windmill_V1()
{
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([85,0,60])
            rotate([0,180,90])
               windblade();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([85,0,-60])
            rotate([0,0,90])
               mirror([1,0,0])
               windblade();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([40,0,-50])
            rotate([180,0,-90])
                windarm();
   for(r=[0,120,240])
         rotate([0,0,r])
            translate([40,0,50])
               rotate([0,0,-90])
                   windarm();
   translate([0,0,60])
      rotate([180,0,0])
         windtop(hole=2.5);
   translate([0,0,-70])
      windwheel();
   translate([0,0,-120])
      windbase();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([40,0,-130])
            rotate([0,0,90])
               windfoot();
   translate([35,0,-70])
      motorwheel();
   translate([45,0,-100])
      rotate([-90,0,-90])
         motorbase();
}
//---------------------------------------------------------|
module windmill_V2()
{
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([85,0,60])
            rotate([0,180,90])
               windblade();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([85,0,-60])
            rotate([0,0,90])
               mirror([1,0,0])
                  windblade();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([40,0,-50])
            rotate([180,0,-90])
                windarm();
   for(r=[0,120,240])
         rotate([0,0,r])
            translate([40,0,50])
               rotate([0,0,-90])
                   windarm();
   translate([0,0,60])
      rotate([180,0,0])
         windtop(bearing=1);
   translate([0,0,-70])
      windgear();
   for(z=[70,-80])
      translate([0,0,z])
         rotate([z>0?180:0,0,0])
            windbearing();
   translate([0,0,-120])
      windbase();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([40,0,-130])
            rotate([0,0,90])
               windfoot();
   translate([35,0,-70])
      motorgear();
   translate([45,0,-100])
      rotate([-90,0,-90])
         motorbase();
}
//---------------------------------------------------------|
module windmill_V3()
{
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([85,0,60])
            rotate([0,180,90])
               windblade();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([85,0,-60])
            rotate([0,0,90])
               mirror([1,0,0])
                  windblade();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([40,0,-50])
            rotate([180,0,-90])
                windarm();
   for(r=[0,120,240])
         rotate([0,0,r])
            translate([40,0,50])
               rotate([0,0,-90])
                   windarm();
   for(z=[60,-70])
      translate([0,0,z])
         rotate([180,0,0])
            windtop(bearing=1);
   for(z=[70,-80])
      translate([0,0,z])
         rotate([z>0?180:0,0,0])
            windbearing();
   translate([0,0,-70])
      windringgear();
   translate([0,0,-120])
      windbase();
   for(r=[0,120,240])
      rotate([0,0,r])
         translate([40,0,-130])
            rotate([0,0,90])
               windfoot();
   translate([35,0,-70])
      motorgear();
   translate([45,0,-100])
      rotate([-90,0,-90])
         motorbase();
}
//---------------------------------------------------------|
module windblade()
{
   difference()
   {
      union()
      {
         translate([0,0,0])
            cylind8r(h=10,r1=10,r2=10,r=1,center=true,fn=fn);
         translate([50,0,0])
            cylind8r(h=10,r1=5,r2=5,r=1,center=true,fn=fn);
         translate([25,5,0])
            rotate([0,0,-5.75])
               cub8([50,5,10],r=1,center=true,fn=fn);
         translate([25,-5,0])
            rotate([0,0,5.75])
               cub8([50,5,10],r=1,center=true,fn=fn);
         translate([0,10,-2.5])
               cub8([20,20,5],r=1,center=true,fn=fn);
         translate([0,20,-2.5])
            cylind8r(h=5,r1=10,r2=10,r=1,center=true,fn=fn);
      }
      translate([0,0,0])
         cylinder(h=10.2,r=5,center=true,$fn=fn);
      translate([0,20,0])
         rotate([0,0,-90])
            windhole();
   }
}
//---------------------------------------------------------|
module windarm()
{
    difference()
   {
     union()
      {
         translate([0,0,0])
            cub8([10,50,5],r=2.5,center=true,fn=fn);
         for(y=[25,-25])
         {
            translate([0,y,0])
               cylind8r(h=5,r1=5,r2=6,r=1,center=true,fn=fn);
            translate([0,y,5])
               rotate([0,0,-90])
                  windjoin();
         }
      }
         for(y=[25,-25])
         {
            translate([0,y,2.5])
               cylinder(h=10.2,r=1.5,center=true,$fn=fn);
         }
   }
}
//---------------------------------------------------------|
module windbase()
{
   difference()
   {
      union()
      {
         translate([0,0,0])
            cylind8r(h=5,r1=25,r2=25,r=1,center=true,fn=fn);
         translate([0,0,2.5])
            cylind8r(h=10,r1=10,r2=10,r=1,center=true,fn=fn);
      }
      translate([0,0,2.5])
         cylinder(h=10.2,r=2,center=true,$fn=fn);
      for(r=[0,120,240])
         rotate([0,0,r])
            translate([15,0,0])
               windhole();
   }
}
//---------------------------------------------------------|
module windfoot()
{
   difference()
   {  
      union()
      {
         translate([0,0,0])
            cub8([10,50,5],r=2.5,center=true,fn=fn);
         translate([0,25,0])
            cylind8r(h=5,r1=5,r2=6,r=1,center=true,fn=fn);
         translate([0,-22.5,0])
            cylind8r(h=5,r1=5,r2=5,r=2.5,center=true,fn=fn);
         translate([0,25,5])
            rotate([0,0,-90])
               windjoin();
      }
      for(y=[25,-22.5])
         translate([0,y,0])
            cylinder(h=15.2,r=1.5,center=true,$fn=fn);
   }
}
//---------------------------------------------------------|
module windtop(bearing=0,hole=4)
{
   difference()
   {  
      translate([0,0,0])
         cylind8r(h=5,r1=25,r2=25,r=1,center=true,fn=fn);
      translate([0,0,0])
         cylinder(h=5.2,r=hole,center=true,$fn=fn);
      for(r=[0,120,240])
      {
         rotate([0,0,r])
            translate([15,0,2.5])
              windhole();
         rotate([0,0,r+60])
            translate([12.5,0,0])
               cylinder(h=10.2,r=4,center=true,$fn=fn);
         if(bearing)
            rotate([0,0,r+24])
               translate([8,0,0])
                  cylinder(h=10.2,r=1.5,center=true,$fn=fn);
      }
   }
}
//---------------------------------------------------------|
module windwheel()
{
   difference()
   {  
      union()
      {
         translate([0,0,0])
            cylind8r(h=5,r1=25,r2=23,r=1,center=true,fn=fn);
         translate([0,0,0])
            cylind8r(h=5,r1=23,r2=25,r=1,center=true,fn=fn);
         for(r=[0,120,240])
         {
            rotate([0,0,r])
               translate([15,0,5])
                  cylind8r(h=5,r1=9,r2=9,r=1,center=true,fn=fn);
         }
      }
      translate([0,0,0])
         cylinder(h=5.2,r=2.5,center=true,$fn=fn);
      for(r=[0,120,240])
      {
         rotate([0,0,r])
            translate([15,0,2.5])
               rotate([0,0,180])
                  windhole();
         rotate([0,0,r+60])
            translate([12.5,0,0])
               cylinder(h=5.2,r=4,center=true,$fn=fn);
      }
   }
}
//---------------------------------------------------------|
module windgear()
{
   difference()
   {  
      union()
      {
         translate([0,0,0])
            gear_external(num_teeth=40,hole_size=4);
         for(r=[0,120,240])
         {
            rotate([0,0,r])
               translate([15,0,5])
                  cylind8r(h=5,r1=9,r2=9,r=1,center=true,fn=fn);
         }
      }
      translate([0,0,0])
         cylinder(h=5.2,r=2,center=true,$fn=fn);
      for(r=[0,120,240])
      {
         rotate([0,0,r])
            translate([15,0,2.5])
               rotate([0,0,180])
                    windhole();
         rotate([0,0,r+60])
            translate([12.5,0,0])
               cylinder(h=5.2,r=4,center=true,$fn=fn);
         rotate([0,0,r+24])
            translate([8,0,0])
               cylinder(h=5.2,r=1.5,center=true,$fn=fn);
         rotate([0,0,r+24])
            translate([8,0,5.1])
               cylinder(h=5.2,r=3,center=true,$fn=fn);
      }
   }
}
//---------------------------------------------------------|
module windringgear()
{
   difference()
   {  
      union()
      {
         translate([0,0,0])
            gear_internal(num_teeth=75,num_hole=0);
         for(r=[0,120,240])
         {
            rotate([0,0,r])
               translate([65,0,0])
                  cylind8r(h=5,r1=7.5,r2=7.5,r=1,center=true,fn=fn);
         }
         for(r=[0,120,240])
         {
            rotate([0,0,r])
               translate([60,0,0])
                  cub8([10,15,5],r=1,center=true,fn=fn);
         }
      }
      for(r=[0,120,240])
      {
         rotate([0,0,r])
            translate([65,0,0])
               cylinder(h=5.2,r=1.5,center=true,$fn=fn);
      }
   }
}
//---------------------------------------------------------|
module windbearing()
{
   difference()
   {
      translate([0,0,0])
         cylind8r(h=10,r1=12.5,r2=12.5,r=1,center=true,fn=fn);
      translate([0,0,0])
         cylinder(h=10.2,r=4,center=true,$fn=fn);
      translate([0,0,2.5])
         cylinder(h=5.2,r=6.5,center=true,$fn=fn);
      for(r=[0,120,240])
         rotate([0,0,r+24])
            translate([8,0,0])
               cylinder(h=10.2,r=1.5,center=true,$fn=fn);
   }
}
//---------------------------------------------------------|
module windjoin()
{
   union()
   {
      translate([0,0,0])
         cylind8r(h=5,r1=5,r2=5,r=1,center=true,fn=fn);
      translate([0,5,0])
         cub8([5,2.5,5],r=1,center=true,fn=fn);
   }
}
//---------------------------------------------------------|
module windhole()
{
   union()
   {
      translate([0,0,0])
         cylinder(h=10.2,r=5,center=true,$fn=fn);
      translate([0,5,0])
         cube([5,2.5,10.2],center=true);
   }
}
//---------------------------------------------------------|
module motorbase()
{
   difference()
   {  
      union()
      {
         translate([0,0,0])
            cub8([20,40,5],r=1,center=true,fn=fn);
         translate([0,15,2.5])
              cub8([20,10,10],r=1,center=true,fn=fn);
      }
      translate([0,17.5,2.5])
           cub8([10,5.2,15],r=2.5,center=true,fn=fn);
      for(x=[5,-5])
         for(y=[-12.5,0])
            translate([x,y,0])
               cube([2,4,5.2],center=true);
   }
}
//---------------------------------------------------------|
module motorwheel()
{
   difference()
   {  
      union()
      {
         translate([0,0,0])
            cylind8r(h=5,r1=5,r2=3,r=1,center=true,fn=fn);
         translate([0,0,0])
            cylind8r(h=5,r1=3,r2=5,r=1,center=true,fn=fn);
      }
      translate([0,0,2.5])
         cylinder(h=10.2,r=1,center=true,$fn=fn);
   }
}
//---------------------------------------------------------|
module motorgear()
{
   translate([0,0,0])
      rotate([0,0,18])
         gear_external(gear_height=10, 
                       num_teeth=10, 
                       hole_size=1);
}
//---------------------------------------------------------|
module cub8(xyz,r,center,fn)
{
   // original cube
   //%cube(xyz,center=true);
   // rounded corners cube
   union() 
   {
      cube([xyz[0]-(r*2),xyz[1]-(r*2),xyz[2]],center=center);
      cube([xyz[0]-(r*2),xyz[1],xyz[2]-(r*2)],center=center);
      cube([xyz[0],xyz[1]-(r*2),xyz[2]-(r*2)],center=center);
      for(x=[(xyz[0]/-2)+r,(xyz[0]/2)-r]) 
      {
         for(y=[(xyz[1]/-2)+r,(xyz[1]/2)-r]) 
         {
            for(z=[(xyz[2]/-2)+r,(xyz[2]/2)-r]) 
            {
            translate([x,y,z])
               sphere(r=r,$fn=fn);
            }
         }
      }
      for(x=[0]) 
      {
         for(y=[(xyz[1]/-2)+r,(xyz[1]/2)-r]) 
         {
            for(z=[(xyz[2]/-2)+r,(xyz[2]/2)-r]) 
            {
            translate([x,y,z]) rotate([0,90,0])
               cylinder(h=xyz[0]-(r*2),
                        r1=r,r2=r,center=center,$fn=fn);
            }
         }
      }
      for(x=[(xyz[0]/-2)+r,(xyz[0]/2)-r]) 
      {
         for(y=[0]) 
         {
            for(z=[(xyz[2]/-2)+r,(xyz[2]/2)-r]) 
            {
            translate([x,y,z]) rotate([90,0,0])
               cylinder(h=xyz[1]-(r*2),
                        r1=r,r2=r,center=center,$fn=fn);
            }
         }
      }
      for(x=[(xyz[0]/-2)+r,(xyz[0]/2)-r]) 
      {
         for(y=[(xyz[1]/-2)+r,(xyz[1]/2)-r]) 
         {
            for(z=[0]) 
            {
            translate([x,y,z]) rotate([0,0,0])
               cylinder(h=xyz[2]-(r*2),
                        r1=r,r2=r,center=center,$fn=fn);
            }
         }
      }
   }
}
//---------------------------------------------------------|
module cylind8r(h,r1,r2,r,center,fn) 
{
   // original cylinder
   //%cylinder(h=h,r1=r1,r2=r2,center=true,$fn=fn);
   // rounded corners cylinder
   pi = 3.1415926535897932384626433832795028841971693993751;
   c1 = 2*pi*r1;
   c2 = 2*pi*r2;
   h1 = c1/fn;
   h2 = c2/fn;
   union() 
   {
      cylinder(h=h,r1=r1-r,r2=r2-r,center=center,$fn=fn);
      cylinder(h=h-(r*2),r1=r1,r2=r2,center=center,$fn=fn);
      for(z=[0:360/fn:360-(360/fn)]) 
      {
         rotate([0,0,z+(360/fn)/2]) 
            translate([r1-r,0,(-h/2)+r]) 
               rotate([90,0,0])
                  cylinder(h=h1,r1=r,r2=r,
                           center=center,$fn=fn);
      }
      for(z=[0:360/fn:360-(360/fn)]) 
      {
         rotate([0,0,z+(360/fn)/2]) 
            translate([r2-r,0,(h/2)-r]) 
               rotate([90,0,0]) 
                  cylinder(h=h2,r1=r,r2=r,
                           center=center,$fn=fn);
      }
   }
}
//---------------------------------------------------------|
module gear_external
(
  // gear parameters
  num_teeth=30,     // number of teeth
  tooth_size=2,   // tooth size
  tooth_clear=0.15, // tooth clear
  tooth_deep=0.15,  // tooth deep
  gear_height=5,    // gear height
  // central hole parameters
  hole_size=2       // Radius of central hole
)
{
   // gear values
   tooth_distance = tooth_size+tooth_clear;         // tooth distance
   gear_radius=(tooth_distance*num_teeth)/3.141592; // gear ray
   tooth_angle=360/num_teeth;                       // tooth rotation
   tooth_end=360-tooth_angle;                       // tooth end
   tooth_radius=tooth_size/2;                       // tooth ray
   // gear rendering
   difference()
   {
      union()
      {
         cylinder(gear_height,
                  gear_radius,
                  gear_radius,center=true,$fn=fn);
         for(gear_angle=[0:tooth_angle:tooth_end])
         {
            rotate([0,0,gear_angle]) translate([gear_radius,0,0])
            {
               cylinder(gear_height,
                        tooth_radius,
                        tooth_radius,center=true,$fn=36);
            }
         }
      }
      for(gear_angle=[0:tooth_angle:tooth_end])
      {
         rotate([0,0,gear_angle+(tooth_angle/2)]) 
            {
            translate([gear_radius-tooth_deep,0,0])
               cylinder(gear_height+0.2,
                        tooth_radius+tooth_clear,
                        tooth_radius+tooth_clear,center=true,$fn=36);
            translate([gear_radius,0,0])
               cube([tooth_deep*2,
                     (tooth_radius+tooth_clear)*2,
                     gear_height+0.2],center=true);
            }
      }
      // central hole 
      cylinder(gear_height+0.2,
               hole_size, 
               hole_size,center=true,$fn=fn);
   }
}
//---------------------------------------------------------|
module gear_internal
(
  // gear parameters
  num_teeth=60,     // number of teeth
  tooth_size=2,     // tooth size
  tooth_clear=0.15, // tooth clear
  tooth_deep=0.15,  // tooth deep
  gear_height=5,    // gear height
  gear_size=10,      // gear size
  // central hole parameters
  num_hole=3,       // number of holes
  hole_size=1.5     // hole size
)
{
   // gear values
   tooth_distance = tooth_size+tooth_clear;         // tooth distance
   gear_radius=(tooth_distance*num_teeth)/3.141592; // gear ray
   tooth_angle=360/num_teeth;                       // tooth rotation
   tooth_end=360+1-tooth_angle;                     // tooth end
   tooth_radius=tooth_size/2;                       // tooth ray
   hole_angle=360/num_hole;                         // hole rotation
   hole_end=360-hole_angle;                         // hole end
   // gear rendering
   difference()
   {
      union()
      {
         difference()
         {
            cylinder(gear_height,
                     gear_radius+gear_size,
                     gear_radius+gear_size,center=true,$fn=60);
            cylinder(gear_height+0.2,
                     gear_radius,
                     gear_radius,center=true,$fn=60);
         } 
         for(gear_angle=[0:tooth_angle:tooth_end])
         {
            rotate([0,0,gear_angle]) translate([gear_radius,0,0])
            {
               cylinder(gear_height,
                        tooth_radius,
                        tooth_radius,center=true,$fn=36);
            }
         }
      }
      for(gear_angle=[0:tooth_angle:tooth_end])
      {
         rotate([0,0,gear_angle+(tooth_angle/2)]) 
            {
            translate([gear_radius+tooth_deep,0,0])
               cylinder(gear_height+0.2,
                        tooth_radius+tooth_clear,
                        tooth_radius+tooth_clear,center=true,$fn=36);
            translate([gear_radius,0,0])
               cube([tooth_deep*2,
                     (tooth_radius+tooth_clear)*2,
                     gear_height+0.2],center=true);
            }
      }
      for(gear_angle=[0:hole_angle:hole_end]) // holes
      {
         rotate([0,0,gear_angle]) 
         {
            translate([gear_radius+(gear_size/2),0,0]) 
            cylinder(gear_height+0.2,
                     hole_size, 
                     hole_size,center=true,$fn=fn);
         }
      }
   }
}
//---------------------------------------------------------|